.include "8515def.inc"		;     
				;     
				;  
.cseg 				; CODE segment
.org	0			; 
	rjmp 	init	 	;     ,
         		 	;  RESET    
.org	$0d			; 
.include "MyLib.inc"		;     
				;    
.def Dat_LCD= r20		; /   LCD

;******   ****************************************
;**    ,  RESET,   		
;**  					
;*************************************************************************
init:
	ldi 	temp, low(RAMEND)	;   
	out 	SPL, temp		;    
	ldi 	temp, high(RAMEND)	;
	out 	SPH, temp		;
	rcall	Config_Port		;    
	rcall	Init_lcd		;    

;******   BUSY      ***********
read_busy:
	clr		temp		;   A  
	out		ddra, temp	; 
	out		porta, temp	; 
	sbi		ddrc, LCD_RW	;  R/W
	cbi		ddrc, LCD_RS	;  RS
	sbi	 	portb, LCD_E	;   0  B ( E=1).
	nop				;   1 
	nop				; 
	nop				; 
	nop				; 
	in	 	dat_lcd, pina	;    
	cbi 	portb, LCD_E		; C  0  B ( E=0)
	ser		temp		;   A  
	out		ddra, temp	; 
	ret

;******    BUSY   ********************
wait_busy:				; 
	rcall	read_busy		; 
	sbrc	dat_lcd, busy		; 
	rjmp	wait_busy		; 
	ret

;******   DDRAM  *******************
	rcall	wait_busy		; 
	ldi		zl,low(text0*2)	;   Z    text0		
	ldi		zh,high(text0*2); 
	ldi		temp2, 30	;     DDRAM	
ddram:	
	lpm				;   flash-  	
	mov 	dat_lcd, r0		; 
	rcall 	lcd_dat			;    DDRAM
	rcall 	wait_busy		; 
	ld 		r0, z+		;   1  Z  flash-
	dec 	temp2			;      
	brne 	ddram			;  


;******   ***********************************************
main:
	ldi		temp, 2		;    
	rcall	lcd_dat			; DDRAM    
	ldi 	r24,5			;   
stop1:	
	rcall 	del200	
	dec 	r24
	brne 	stop
	ldi 	r24, 10			;   
shift:
	ldi 	dat_lcd,$18		;     
	rcall 	lcd_com
	rcall 	del200			;  ~1/5    4 
	dec 	r24
	brne 	shift
	ldi 	r24,5			;      
stop:	
	rcall 	del200	
	dec 	r24
	brne 	stop
	rjmp 	main			;  

;******   **********************************************
INIT_LCD:            				;  
     	rcall	DEL_5MS				; 15 
	rcall	DEL_5MS				;
	rcall	DEL_5MS				;
	ldi	Dat_LCD,$38			; 8 ,2 , 57 
	rcall	lcd_dat 			;    
	rcall	DEL_5MS				; 5.4 
	ldi	Dat_LCD,$38			; 8 ,2 , 57 
	rcall	lcd_dat				;    
	rcall	DEL_100us			; 100 
	ldi	Dat_LCD,$38			; 8 ,2 , 57 
	rcall	lcd_dat				;    
	rcall	DEL_100us			; 100 
	ldi	Dat_LCD,$38			; 8 ,2 , 57 
	rcall	lcd_dat				;    
	rcall	DEL_100us			; 100 
	ldi	Dat_LCD,$04			; 
	rcall	lcd_dat				;    
	rcall	DEL_100us			; 100 
	ldi	Dat_LCD,$01			; , .   
	rcall	lcd_dat				;    
	rcall	DEL_5MS				; 5.4 
	ldi	Dat_LCD,$0c			;. , . , .
	rcall	lcd_dat				;    
	rcall	DEL_100us			; 100 ; 
	ret

;******     *******************************************
lcd_com:
	in		temp, ddrc	;     
	andi	temp, 0b11001111	;  RS  R/W ( PC4, PC5)
	out		ddrc, temp	; 
	sbi	 	portb, LCD_E	;   0  B( E=1).
	out 	porta, dat_lcd		;      LCD
	cbi 	portb, LCD_E		; C  0  B( E=0)
	ret

;******     ********************************************
lcd_dat:
	cbi		ddrc, LCD_RW	;  R/W
	sbi		ddrc, LCD_RS	;  RS ????????????????????????
	sbi	 	portb, LCD_E	;   0  B( E=1). 
	out 	porta, dat_lcd		;  ASCII     LCD
	cbi 	portb, LCD_E		; C  0  B( E=0)
	ret
DEL_5MS:				; 5 
	ldi	R25,27
d:	ldi	R24,255
d1:	dec	R24
	brne	d1
	dec	R25
	brne	d  
	ret


DEL_100us:				; 100 
	ldi	R25,125
d2:	dec	R25
	brne	d2
	ret  

;******    *****************************
del200:
	ldi		temp2, 5
d3:	ser		temp1
d4:	ldi		temp, 209
d5:	dec		temp
	brne	d5
	dec		temp1
	brne	d4
	dec		temp2
	brne	d3
	ret

;******  flash -       **
.org $200
text0:	.DB  168,112,111,180,112, 97,188,188,97	;